searchNodes=[{"doc":"Loads env vars using an adapter-based approach.Exenv dynamically assigns env vars on application start using whatever adapters have been configured to run. By default, Exenv is setup to use the included Exenv.Adapters.Dotenv adapter - loading env vars from a .env file in your projects directory on startup.ConfigurationIf you need to further configure Exenv - it is typically done via application config.config :exenv, [ adapters: [ {Exenv.Adapters.Dotenv, [file: &quot;path/to/.env&quot;]} ] ]You can simply list the adapters and any options you would like to pass to it via {MyAdapter, opts} - where opts is a keyword list of options defined by the adapter.Alternatively, you can also configure Exenv to be used via your own supervision tree. In this case simply add the following to your config:config :exenv, start_on_application: falseYou can then add Exenv to your supervisor.children = [ {Exenv, [adapters: [{Exenv.Adapters.Dotenv, [file: &quot;path/to/.env&quot;]}]]} ]EncryptionExenv has support for encryption out of the box. This allows you to keep an encrypted secrets file checked into your repository. Please see Exenv.Encryption for more details.","ref":"Exenv.html","title":"Exenv","type":"module"},{"doc":"Loads all env vars using the adapters defined within our config.","ref":"Exenv.html#load/0","title":"Exenv.load/0","type":"function"},{"doc":"Loads all env vars using the adapter config provided.","ref":"Exenv.html#load/1","title":"Exenv.load/1","type":"function"},{"doc":"Loads env vars using the adapter and options provided.","ref":"Exenv.html#load/2","title":"Exenv.load/2","type":"function"},{"doc":"Returns {:ok, binary}, where binary is a binary data object that contains the contents of path, or {:error, reason} if an error occurs.You can optionally pass an mfa {module, function, args} that will be evaluated and should return the intended path. This allows for runtime setup.Options:encryption - options used to decrypt the binary result if required. # Decrypts the file using the MASTER_KEY env var [encryption: true] # Decrypts the file using the master key file [encryption: [master_key: &quot;/path/to/master.key&quot;]]","ref":"Exenv.html#read_file/2","title":"Exenv.read_file/2","type":"function"},{"doc":"Starts the Exenv process.","ref":"Exenv.html#start_link/1","title":"Exenv.start_link/1","type":"function"},{"doc":"","ref":"Exenv.html#t:on_load/0","title":"Exenv.on_load/0","type":"type"},{"doc":"Defines an Exenv adapter.An Exenv adapter is simply a module that adheres to the callbacks required. It can be as simple as:defmodule MyAdapter do use Exenv.Adapter @imple true def load(opts) do # load some system env vars :ok end endSome adapters may be simple and do not require a process on their own. But if some form of state is needed, we can also make our adapter process-based. If we define our adapter within the normal Exenv startup flow, this process will then be automatically started and supervised. Below is an example:defmodule MyAdapter do use Exenv.Adapter use GenServer @impl true def start_link(opts) do GenServer.start_link(__MODULE__, opts, name: __MODULE__) end @impl true def init(opts) do {:ok, opts} end @impl true def load(opts) do # load some system env vars GenServer.call(__MODULE__, {:load, opts}) end @impl true def handle_call({:load, opts}, _from, config) do # load some system env vars {:reply, :ok, config} end endAnd thats it! We can know start using our new adapter.Reading FilesIf your adapter reads files in order to load env vars, it is recommended that Exenv.read_file/2 is used. This will enabled support for secrets encryption. If a user passes the one of the following with your options, the file will be automatically decrypted. # Decrypts the file using MASTER_KEY env var [encryption: true] # Decrypts the file using a master key file [encryption: [master_key: &quot;/path/to/master.key&quot;]]","ref":"Exenv.Adapter.html","title":"Exenv.Adapter","type":"behaviour"},{"doc":"Loads the system env vars using the adapter and options provided.","ref":"Exenv.Adapter.html#c:load/1","title":"Exenv.Adapter.load/1","type":"callback"},{"doc":"Starts the adapter process if required.","ref":"Exenv.Adapter.html#c:start_link/1","title":"Exenv.Adapter.start_link/1","type":"callback"},{"doc":"","ref":"Exenv.Adapter.html#t:config/0","title":"Exenv.Adapter.config/0","type":"type"},{"doc":"","ref":"Exenv.Adapter.html#t:result/0","title":"Exenv.Adapter.result/0","type":"type"},{"doc":"","ref":"Exenv.Adapter.html#t:t/0","title":"Exenv.Adapter.t/0","type":"type"},{"doc":"Loads env vars from .env files.Below is a simple example of a .env file:KEY1=val KEY2=val KEY3=valAssuming we have the above file in our project root directory, we would be able to access any of the above env vars.System.get_env(&quot;KEY1&quot;)By default, this adapter is set to start automatically on Exenv startup. It also has support for encrypted .env files.","ref":"Exenv.Adapters.Dotenv.html","title":"Exenv.Adapters.Dotenv","type":"module"},{"doc":"Loads the system env vars from a .env specified in the options.Options:file - The file path or mfa that evaluates to a file path in which to read the .env from. By default this is a .env file in your projects root directory.:encryption - Options used to decrypt files. Please see Exenv.read_file/2 for the options available.","ref":"Exenv.Adapters.Dotenv.html#load/1","title":"Exenv.Adapters.Dotenv.load/1","type":"function"},{"doc":"Provides support for secrets encryption.Exenv supports file encryption out of the box. As a result, most adapters will also support encryption. This allows you to keep an encrypted secrets file checked into your repository. As long as you provide access to a master key via the env var &quot;MASTER_KEY&quot; or file, you will be able to transparently load env vars from your encrypted secrets file.To start using encryption, you must first generate a master key: mix exenv.master_key /config/master.keyThe above will generate a master key at /config/master.keyYou can then encrypt your secrets file: mix exenv.encrypt /config/master.key /config/.envThe above will encrypt the /config/.env file using the key at /config/master.keyYou can also decrypt your secrets at any time if you wish to add to them:mix exenv.decrypt /config/master.key /config/.env.encThe above will decrypt the /config/.env.enc file using the key at /config/master.key and create a new file at /config/.env contining the decrypted secrets.Encryption options are passed along with adapter options. Please consult the options available to individual adapters for further details.{Exenv.Adapters.Dotenv, [file: &quot;path/to/.env&quot;, encryption: true]}","ref":"Exenv.Encryption.html","title":"Exenv.Encryption","type":"module"},{"doc":"Creates a master key at path.Returns the path to the new master key file.","ref":"Exenv.Encryption.html#create_master_key!/1","title":"Exenv.Encryption.create_master_key!/1","type":"function"},{"doc":"Decrypts the secrets at path using key.Returns the decrypted secrets.","ref":"Exenv.Encryption.html#decrypt_secrets!/2","title":"Exenv.Encryption.decrypt_secrets!/2","type":"function"},{"doc":"Encrypts the secrets located at path using key.Returns the path to the new encrypted file.","ref":"Exenv.Encryption.html#encrypt_secrets!/2","title":"Exenv.Encryption.encrypt_secrets!/2","type":"function"},{"doc":"Attempts to get the master key.If provided path it will read the key from path. If not provided a path, it will get the contents of the env var &quot;MASTER_KEY&quot;.","ref":"Exenv.Encryption.html#get_master_key!/1","title":"Exenv.Encryption.get_master_key!/1","type":"function"},{"doc":"","ref":"Exenv.Test.html","title":"Exenv.Test","type":"module"},{"doc":"Asserts that a single env var exists.Examplesrefute_var &quot;KEY&quot;, &quot;val&quot;","ref":"Exenv.Test.html#assert_var/2","title":"Exenv.Test.assert_var/2","type":"function"},{"doc":"Asserts that a list of env vars exist.Examplesassert_vars [{&quot;KEY&quot;, &quot;val&quot;}]","ref":"Exenv.Test.html#assert_vars/1","title":"Exenv.Test.assert_vars/1","type":"function"},{"doc":"Refutes that a single env var exists.Examplesrefute_var &quot;KEY&quot;, &quot;val&quot;","ref":"Exenv.Test.html#refute_var/2","title":"Exenv.Test.refute_var/2","type":"function"},{"doc":"Refutes that a list of env vars exist.Examplesrefute_vars [{&quot;KEY&quot;, &quot;val&quot;}]","ref":"Exenv.Test.html#refute_vars/1","title":"Exenv.Test.refute_vars/1","type":"function"},{"doc":"Resets a list of env vars to empty strings.Examplesreset_env_vars [{&quot;KEY&quot;, &quot;val&quot;}]","ref":"Exenv.Test.html#reset_env_vars/1","title":"Exenv.Test.reset_env_vars/1","type":"function"},{"doc":"Sets up Exenv for a test with the provided options.Examplessetup_exenv(adapters: [{MyAdapter, opts}])","ref":"Exenv.Test.html#setup_exenv/1","title":"Exenv.Test.setup_exenv/1","type":"function"},{"doc":"Decrypts a file using the provided master.key.The encrypted file should end in .enc.mix exenv.decrypt /config/master.key /config/secrets.env.enc","ref":"Mix.Tasks.Exenv.Decrypt.html","title":"Mix.Tasks.Exenv.Decrypt","type":"task"},{"doc":"Encrypts a file using the provided master.key.The encrypted file will use the existing file name with the addition of .enc. The original unencrypted secrets file will be added to your .gitignore.mix exenv.decrypt /config/master.key /config/secrets.env","ref":"Mix.Tasks.Exenv.Encrypt.html","title":"Mix.Tasks.Exenv.Encrypt","type":"task"},{"doc":"Generates a master key file at the given path.The generated file will be added to your .gitignore file.mix exenv.master_key /config/master.key","ref":"Mix.Tasks.Exenv.MasterKey.html","title":"Mix.Tasks.Exenv.MasterKey","type":"task"},{"doc":"","ref":"Exenv.Error.html","title":"Exenv.Error","type":"exception"},{"doc":"Exenv Exenv provides an adapter-based solution to loading environment variables from external sources.It comes with the following adapter:Exenv.Adapters.Dotenv (load from .env files)But has support from external adapters as well:Exenv.Adapters.Yaml (load from .yml files)","ref":"readme.html","title":"Exenv","type":"extras"},{"doc":"This package can be installed by adding exenv to your list of dependencies in mix.exs:def deps do [ {:exenv, &quot;~&gt; 0.3&quot;} ] end","ref":"readme.html#installation","title":"Exenv - Installation","type":"extras"},{"doc":"Please see HexDocs for additional documentation. This readme provides a brief overview, but it is recommended that the docs are used.","ref":"readme.html#documentation","title":"Exenv - Documentation","type":"extras"},{"doc":"If all you want is to load a .env file on application start - then you're already done! Out of the box, Exenv is configured to start itself with the Exenv.Adapters.Dotenv adapter configured with sane defaults. This means autoloading on application start - with the .env file required to be within your projects root directory.","ref":"readme.html#getting-started","title":"Exenv - Getting Started","type":"extras"},{"doc":"If you need finer grained control of things, Exenv provides extensive config mechansims.We can pass configuration options to Exenv from application config.config :exenv, [ adapters: [ {Exenv.Adapters.Dotenv, [file: &quot;path/to/.env&quot;]} ] ]You can also run Exenv via your own supervision tree. In this case, you must instruct Exenv not to start itself.config :exenv, start_on_application: falseWhich allows you to add Exenv to your own application.defmodule MySupervisor do use Supervisor def start_link(opts) do Supervisor.start_link(__MODULE__, :ok, opts) end def init(:ok) do children = [ {Exenv, [adapters: [{Exenv.Adapters.Dotenv, [file: &quot;path/to/.env&quot;]}]]} ] Supervisor.init(children, strategy: :one_for_one) end endOptions passed to the child_spec/1 callback take precedence over any application config.By default, all adapters will autoload their environment vars when Exenv starts up. You can override this behaviour on a per-adapter basis, by simply passing the autoload: false key within your adapter config.[ adapters: [ {Exenv.Adapters.Dotenv, [autoload: false, file: &quot;path/to/.env&quot;]} ] ]You must then manually load all env vars from your defined adapters:Exenv.load()","ref":"readme.html#configuration","title":"Exenv - Configuration","type":"extras"},{"doc":"Any location where you pass a file path you can choose to instead pass an mfa which will be run and should evaluate to a proper file path. This allows for easier runtime setup of files.config :exenv, [ adapters: [ {Exenv.Adapters.Dotenv, [file: {MyApp, :get_dotenv, []}]} ] ]","ref":"readme.html#runtime-path-evaluation","title":"Exenv - Runtime path evaluation","type":"extras"},{"doc":"Exenv has secrets encryption out of the box. Support will depend on the whether the adapter provides it. Using secrets encryption allows you to keep an encrypted version of your secrets checked into your repository. As long as the master key is accessible, these secrets can then be decrypted.To get started with secrets encryption, first generate a master key.mix exenv.master_key /config/master.keyThis will generate a new master key at /config/master.key. You can then encrypt your secrets file.mix exenv.encrypt /config/master.key /config/.envThis will encrypt the contents of /config/.env using /config/master.key. A new file will then be generated at /config/.env.enc with your encrypted secrets.You must then provide the proper options to your adapters to enable encryption.{Exenv.Adapters.Dotenv, [file: &quot;path/to/.env.enc&quot;, encryption: true]}The above will attempt to decrypt &quot;path/to/.env.enc&quot; using the contents of the &quot;MASTER_KEY&quot; env var. Alternatively, you can also provide a direct path to the master key file.{Exenv.Adapters.Dotenv, [file: &quot;path/to/.env.enc&quot;, encryption: [master_key: &quot;path/to/master.key&quot;]]}To edit your secrets, you just need to decrypt the original encrypted secrets, and rencrypt the edited file.mix exenv.decrypt /config/master.key /config/.env.enc ## Add to file mix exenv.encrypt /config/master.key /config/.env","ref":"readme.html#encryption","title":"Exenv - Encryption","type":"extras"}]